## apt-cacher-ng 0.5.14

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
PROJECT(ACNG CXX C)
INCLUDE_DIRECTORIES(. ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR} "include")

SET(FLAGS_ACNG " -g -O2 -pthread -Wall -D_FILE_OFFSET_BITS=64 ")

# minimum prqs
list(APPEND AcngLdList pthread z bz2)

INCLUDE(CheckIncludeFiles)
INCLUDE(CheckCXXSourceCompiles)

#INCLUDE(FindZLIB) # broken, hangs for 10 seconds
# header check should be enough, gzip should be everywhere nowadays
#CHECK_INCLUDE_FILES("gzip.h" HAVE_ZLIB)
FIND_PATH(HAVE_ZLIB zlib.h )
if(NOT HAVE_ZLIB)
   message(FATAL_ERROR "apt-cacher-ng requires gzip library and development files ${HAVE_ZLIB}")
endif(NOT HAVE_ZLIB)

INCLUDE(FindBZip2)
if (BZIP2_FOUND)
   SET(HAVE_LIBBZ2 1)
   MARK_AS_ADVANCED(HAVE_LIBBZ2)
else (BZIP2_FOUND)
   message(FATAL_ERROR "apt-cacher-ng requires bzip2 library and development files")
endif (BZIP2_FOUND)

INCLUDE_DIRECTORIES(${BZIP2_INCLUDE_DIR})

SET(CMAKE_REQUIRED_FLAGS "-Wl,--as-needed")
SET(TESTSRC "int main() {return 0;}")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_WL_AS_NEEDED)
SET(CMAKE_REQUIRED_FLAGS "")

SET(CMAKE_REQUIRED_LIBRARIES lzma)
SET(TESTSRC "
#include <lzma.h>
lzma_stream t; int main(){ return lzma_stream_decoder (&t, 32000000, LZMA_TELL_UNSUPPORTED_CHECK | LZMA_CONCATENATED); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_LZMA)
IF(HAVE_LZMA)
   list(APPEND AcngLdList lzma)
ELSE(HAVE_LZMA)
   MESSAGE("XZ (liblzma) not found or not working, disabling support")
   SET(HAVE_LZMA )
ENDIF(HAVE_LZMA)
SET(CMAKE_REQUIRED_LIBRARIES "")

SET(TESTSRC "
#include <wordexp.h>
int main(int argc, char **argv) { wordexp_t p; return wordexp(*argv, &p, 0); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_WORDEXP)

SET(TESTSRC "
#include <glob.h>
int main(int argc, char **argv) { glob_t p; return glob(*argv, 0, 0, &p); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_GLOB)

SET(TESTSRC "
#define _XOPEN_SOURCE 600
#include <fcntl.h>
int testme(int fd, off_t offset, off_t len, int) { return posix_fadvise(fd, offset, len, POSIX_FADV_SEQUENTIAL); }; int main(int,char**){return testme(0,0,0,0);}
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_FADVISE)
# Solaris fallback
IF(NOT HAVE_FADVISE)
SET(TESTSRC "
#include <fcntl.h>
int testme(int fd, off_t offset, off_t len, int) { return posix_fadvise(fd, offset, len, POSIX_FADV_SEQUENTIAL); }; int main(int,char**){return testme(0,0,0,0);}
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_FADVISE)
ENDIF(NOT HAVE_FADVISE)

SET(TESTSRC "
#include <sys/mman.h>
int testme(void *addr, size_t length, int advice) { return posix_madvise(addr, length, advice); } int main(int,char**){return testme(0,0,0);}
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_MADVISE)

SET(TESTSRC "
#define _GNU_SOURCE
#include <linux/falloc.h>
#include <fcntl.h>
int main() { int fd=1; return fallocate(fd, FALLOC_FL_KEEP_SIZE, 1, 2); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_LINUX_FALLOCATE)

SET(TESTSRC "
#include <sys/sendfile.h>
int main(int argc, char **argv) { off_t yes(3); return (int) sendfile(1, 2, &yes, 4); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_LINUX_SENDFILE)

FIND_LIBRARY(HAVE_SOCKETLIB socket) # separate socket lib looks like Solaris-like environment
if(HAVE_SOCKETLIB)
   link_libraries(socket nsl)
endif(HAVE_SOCKETLIB)


INCLUDE(CheckTypeSize)
CHECK_TYPE_SIZE(int SIZE_INT)
CHECK_TYPE_SIZE(long SIZE_LONG)

SET(TESTSRC "
#include <memory>
int main() { return NULL != std::shared_ptr<int>(new int(1)); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_MEMORY_SPTR)

SET(TESTSRC "
#include <tr1/memory>
int main() { return NULL != std::tr1::shared_ptr<int>(new int(1)); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_TR1_MEMORY)

set(CMAKE_REQUIRED_INCLUDES . ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR})

SET(TESTSRC "
#include <boost/smart_ptr.hpp>
int main() { return NULL != boost::shared_ptr<int>(new int(1)); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_BOOST_SMARTPTR)
set(CMAKE_REQUIRED_INCLUDES "")

if(NOT HAVE_BOOST_SMARTPTR)
   if(NOT HAVE_TR1_MEMORY)
      if(NOT HAVE_MEMORY_SPTR)
         message(FATAL_ERROR "Could not find a working smart pointer implementation. Please read documentation and include boost headers.")
      endif(NOT HAVE_MEMORY_SPTR)
   endif(NOT HAVE_TR1_MEMORY)
endif(NOT HAVE_BOOST_SMARTPTR)

######################################
# checks done, save configuration    #
######################################

CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/include/acsyscap.h.in" "${CMAKE_BINARY_DIR}/acsyscap.h")


# I don't need -rdynamic
SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")

FILE(GLOB SRCS "${CMAKE_SOURCE_DIR}/source/*.cc")
ADD_EXECUTABLE(apt-cacher-ng ${SRCS})
list(REMOVE_DUPLICATES AcngLdList)
TARGET_LINK_LIBRARIES(apt-cacher-ng ${AcngLdList})

SET_TARGET_PROPERTIES(apt-cacher-ng PROPERTIES COMPILE_FLAGS ${FLAGS_ACNG})


ADD_EXECUTABLE(in.acng client/client.cc)
SET_TARGET_PROPERTIES(in.acng PROPERTIES COMPILE_FLAGS ${FLAGS_ACNG})

IF(HAVE_WL_AS_NEEDED)
SET_TARGET_PROPERTIES(in.acng apt-cacher-ng PROPERTIES LINK_FLAGS  -Wl,--as-needed)
# funny hack, link with gcc and avoid libstdc++/libm (since no STL parts used
# there). However, it needs to be investigated - the alternative linking makes
# the binary 40kb larger, might include higher relocation costs and bigger
# chunks of unique memory while libstdc++ needs to be loaded anyway for the
# server process.
#TARGET_LINK_LIBRARIES(in.acng supc++)
#SET_TARGET_PROPERTIES(in.acng PROPERTIES LINKER_LANGUAGE C)
ENDIF(HAVE_WL_AS_NEEDED)


############################################
## Attempt to build acngfs where possible ##
############################################

include(FindPkgConfig)
pkg_check_modules(fuse fuse)

SET(TESTSRC "
#define _FILE_OFFSET_BITS 64
#define FUSE_USE_VERSION 26
#include <fuse.h>
int main() { return 0; }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_FUSE_26)
if(fuse_FOUND AND HAVE_FUSE_26)

ADD_EXECUTABLE(acngfs fs/httpfs.cc source/lockable.cc source/header.cc source/caddrinfo.cc source/acbuf.cc source/meta.cc source/acfg.cc source/acfg_defaults.cc)

set(acngfs_cflags "${FLAGS_ACNG} -DMINIBUILD")

# what a mess... convert sepator back to space
foreach(arg ${fuse_CFLAGS})
   set(acngfs_cflags "${acngfs_cflags} ${arg}")
endforeach(arg ${fuse_CFLAGS})


#message("hm, ${acngfs_cflags}")
SET_TARGET_PROPERTIES(acngfs PROPERTIES COMPILE_FLAGS "${acngfs_cflags}" )
TARGET_LINK_LIBRARIES(acngfs ${fuse_LDFLAGS})

IF(HAVE_WL_AS_NEEDED)
SET_TARGET_PROPERTIES(acngfs PROPERTIES LINK_FLAGS  -Wl,--as-needed)
ENDIF(HAVE_WL_AS_NEEDED)


else(fuse_FOUND AND HAVE_FUSE_26)
   message("FUSE not found or incompatible, not building acngfs")
endif(fuse_FOUND AND HAVE_FUSE_26)

=== debian/changelog ===
apt-cacher-ng (0.5.14) unstable; urgency=low

  * Disabled acngfs build on hurd because of missing fuse library
  * Added Brazilian Portuguese Translation from Adriano Rafael
    Gomes (closes: #610414)
  * added option to append arbitrary data to request headers, default contains
    remote proxy cache control data (closes: #613816)
  * changing version scheme to native

 -- Eduard Bloch <blade@debian.org>  Fri, 18 Feb 2011 23:04:33 +0100

apt-cacher-ng (0.5.13-1) unstable; urgency=low

  * New upstream version
  * logrotate configuration for the *.err files
  * silent fix of incorrect Ubuntu mirror path in backends_ubuntu.default
    (alioth task 312888)

 -- Eduard Bloch <blade@debian.org>  Sun, 06 Feb 2011 19:56:57 +0100

apt-cacher-ng (0.5.12-1) unstable; urgency=low

  * New upstream version
    + implements easier removal of cruft via web the inteface (closes: #546790)
    + added http://ftp.debian.org/debian/ to the regular mirror list in
      deb_mirrors.gz (closes: #605426)
  * fixed last-resort Ubuntu mirror picking code, now including the /ubuntu
    path component lost in a few cases

 -- Eduard Bloch <blade@debian.org>  Thu, 02 Dec 2010 23:09:38 +0100

apt-cacher-ng (0.5.11-1) unstable; urgency=low

  * New upstream version
    + return explicit Content-Length (including zero size) except for
      body-less status responses (closes: 603463)
    + more 0.5.7 regressions fixes

 -- Eduard Bloch <blade@debian.org>  Thu, 18 Nov 2010 22:41:50 +0100

apt-cacher-ng (0.5.10-1) unstable; urgency=medium

  * New upstream version
    + fixes import function broken since 0.5.7

 -- Eduard Bloch <blade@debian.org>  Tue, 09 Nov 2010 01:09:22 +0100

apt-cacher-ng (0.5.9-1) unstable; urgency=low

  * New upstream version
    + adds code to prevent request storms from networks with "special"
      configuration (closes: #598469)

 -- Eduard Bloch <blade@debian.org>  Fri, 05 Nov 2010 23:46:52 +0100

apt-cacher-ng (0.5.8-1) unstable; urgency=low

  * New upstream version

 -- Eduard Bloch <blade@debian.org>  Mon, 01 Nov 2010 15:22:25 +0100

apt-cacher-ng (0.5.7-1) experimental; urgency=medium

  * New upstream version
  * Typos in acng.conf fixed (thanks, closes: 599328)

 -- Eduard Bloch <blade@debian.org>  Wed, 20 Oct 2010 18:42:32 +0200

apt-cacher-ng (0.5.6-1) unstable; urgency=medium

  * New upstream version

 -- Eduard Bloch <blade@debian.org>  Sun, 12 Sep 2010 23:16:43 +0200

apt-cacher-ng (0.5.5-1) unstable; urgency=low

  * New upstream version
    + fixes corruption of error page status line
    + better handling of d-i files expiration
    + not downloading unneeded files in expiration

 -- Eduard Bloch <blade@debian.org>  Sun, 12 Sep 2010 23:09:50 +0200

apt-cacher-ng (0.5.4-1) experimental; urgency=low

  * New upstream version
    + solves missing sys/stat.h inclusion (closes: #594765)
    + fixes on old leak of thread memory (now really)
    + lzma reading support

 -- Eduard Bloch <blade@debian.org>  Sun, 29 Aug 2010 15:34:38 +0200

apt-cacher-ng (0.5.3-1) experimental; urgency=low

  * New upstream version
    + lots of internal changes, including obvious memory leaks
  * created doc-base file

 -- Eduard Bloch <blade@debian.org>  Wed, 25 Aug 2010 23:38:26 +0200

apt-cacher-ng (0.5.2-1) experimental; urgency=low

  * New upstream version
    + closes: #590291 (FTBFS with recent compilers)
    + kfreebsd compilation fixes
    + fixes a possible cause of #546790

 -- Eduard Bloch <blade@debian.org>  Sat, 07 Aug 2010 12:51:28 +0200

apt-cacher-ng (0.5.1-1) unstable; urgency=low

  * New upstream version
    + header inclusion cleanup (closes: #590291)
    + kfreebsd related fixes
    + long outstanding user interface fixes and various regression fixes

 -- Eduard Bloch <blade@debian.org>  Wed, 28 Jul 2010 01:17:33 +0200

apt-cacher-ng (0.5-1) unstable; urgency=low

  * New upstream version
    + initiates the connection shutdown correctly, prevents freezes with
      clients that wait for server (closes: #589630)
    + now respecting umask value in creation permissions (closes: #589410),
      also makes the default permissions configurable through DirPerms and
      FilePerms variables

 -- Eduard Bloch <blade@debian.org>  Mon, 19 Jul 2010 22:45:48 +0200

apt-cacher-ng (0.4.9-2) unstable; urgency=low

  * Minor change to support Ubuntu release notes delivery with GET 
    parameters (closes: #588662)

 -- Eduard Bloch <blade@debian.org>  Sun, 11 Jul 2010 11:06:49 +0200

apt-cacher-ng (0.4.9-1) unstable; urgency=low

  * New upstream version
    + fixes LFS settings inconsistencies (closes: #588048), thanks
      to M. Vefa Bicakci

 -- Eduard Bloch <blade@debian.org>  Tue, 06 Jul 2010 00:59:21 +0200

apt-cacher-ng (0.4.8-1) unstable; urgency=low

  * New upstream version
    + fixes FTBFS with recent glibc (Ubuntu bug 596452)
    + adds ddeb files to package filter (Ubuntu bug 596075)
    + allow pass-through mode for specified domains/URLs (Ubuntu bug 530524)
    + modified regex creation (only at startup time now), may be a workaround
      for Debian bug #571536, Ubuntu bugs 523408, 532353, 585957

 -- Eduard Bloch <blade@debian.org>  Fri, 02 Jul 2010 08:40:07 +0200

apt-cacher-ng (0.4.7-1) unstable; urgency=low

  * New upstream version 
    + supports fallback backends descriptions which are used when the file is
      specified in the config but not configured properly. Intended to help
      in a heterogeneous Debian/Ubuntu environment (closes Ubuntu tasks
      398998 and 557316)
    + Fixes potential socket leak in mixed IPv4/v6 setups (maybe closes: #529744
      and Ubuntu bug 572095)
  * Added Vietnamese debconf translation from Clytie Siddall (closes: #576154)
  * Added Spanish translation update from Omar Campagne (closes: #578143)

 -- Eduard Bloch <blade@debian.org>  Wed, 10 Mar 2010 22:53:32 +0100

=== debian/control ===
Source: apt-cacher-ng
Section: net
Priority: optional
Maintainer: Eduard Bloch <blade@debian.org>
Build-Depends: debhelper (>= 7), cmake (>= 2.6.2), libbz2-dev, zlib1g-dev, liblzma-dev, libfuse-dev [!hurd-i386], pkg-config
Standards-Version: 3.9.1
Homepage: http://www.unix-ag.uni-kl.de/~bloch/acng/

Package: apt-cacher-ng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Recommends: perl (>> 5.8), ed
Suggests: doc-base
Description: caching proxy server for software repositories
 Apt-Cacher NG is a caching proxy for downloading packages from Debian-style
 software repositories (or possibly from other types).
 .
 The main principle is that a central machine hosts the proxy for a local
 network, and clients configure their APT setup to download through it.
 Apt-Cacher NG keeps a copy of all useful data that passes through it, and when
 a similar request is made, the cached copy of the data is delivered without
 being re-downloaded.
 .
 Apt-Cacher NG has been designed from scratch as a replacement for
 apt-cacher, but with a focus on maximizing throughput with low system
 resource requirements. It can also be used as replacement for apt-proxy and
 approx with no need to modify clients' sources.list files.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

SHELL=/bin/bash
CDIR=$(CURDIR)/debian/apt-cacher-ng/etc/apt-cacher-ng/

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
        NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif


CXXFLAGS=$(CFLAGS)
export CXXFLAGS

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp


build: build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE) -j$(NUMJOBS)
	# may fail if halibut is not installed, doesn't matter
	-$(MAKE) doc
	#docbook-to-man debian/apt-cacher-ng.sgml > apt-cacher-ng.1
	@-test -d ../unstripped && cp build/apt-cacher-ng ../unstripped/apt-cacher-ng.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') || true
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	$(MAKE) $(MAKEFLAGS) distclean || true
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# Add here commands to install the package into debian/apt-cacher-ng.
	install build/apt-cacher-ng $(CURDIR)/debian/apt-cacher-ng/usr/sbin/apt-cacher-ng
	install build/in.acng expire-caller.pl urlencode-fixer.pl distkill.pl $(CURDIR)/debian/apt-cacher-ng/usr/lib/apt-cacher-ng/
	# optional
	-install build/acngfs $(CURDIR)/debian/apt-cacher-ng/usr/lib/apt-cacher-ng/
	cp -a conf/{*mirror*,*.html,*.css} $(CURDIR)/debian/apt-cacher-ng/usr/lib/apt-cacher-ng
	cp -a conf/*.conf $(CDIR)
	> $(CDIR)/backends_debian
	> $(CDIR)/backends_debvol
	> $(CDIR)/backends_ubuntu
	cd $(CDIR) && cp -s ../../usr/lib/apt-cacher-ng/{*mirror*,*.html,*.css} . 
	ln -sf ../../var/lib/apt-cacher-ng/backends_debian.default $(CDIR)/backends_debian.default
	ln -sf ../../var/lib/apt-cacher-ng/backends_ubuntu.default $(CDIR)/backends_ubuntu.default

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples conf/*.conf conf/debrep.hooks
#	dh_install
#	dh_installmenu
	dh_installdebconf	
	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
	dh_installinit
	dh_installcron
#	dh_installinfo
	dh_installman doc/man/*.8
	#dh_installman doc/man/apt-cacher-ng.8
	dh_link
	dh_strip
	dh_compress -X.pdf
	dh_fixperms
#	dh_perl
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## apt-cacher-ng 0.6.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 PROJECT(ACNG CXX C)
 INCLUDE_DIRECTORIES(. ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR} "include")
 
-SET(FLAGS_ACNG " -g -O2 -pthread -Wall -D_FILE_OFFSET_BITS=64 ")
+SET(FLAGS_ACNG " -pthread -Wall -D_FILE_OFFSET_BITS=64 ")
 
 # minimum prqs
 list(APPEND AcngLdList pthread z bz2)
@@ -99,10 +99,12 @@
    link_libraries(socket nsl)
 endif(HAVE_SOCKETLIB)
 
-
 INCLUDE(CheckTypeSize)
 CHECK_TYPE_SIZE(int SIZE_INT)
 CHECK_TYPE_SIZE(long SIZE_LONG)
+
+INCLUDE(TestBigEndian)
+TEST_BIG_ENDIAN(WORDS_BIGENDIAN)
 
 SET(TESTSRC "
 #include <memory>
@@ -174,24 +176,24 @@
 include(FindPkgConfig)
 pkg_check_modules(fuse fuse)
 
+set(acngfs_cflags "${FLAGS_ACNG} -DMINIBUILD")
+# what a mess... convert sepator back to space
+foreach(arg ${fuse_CFLAGS})
+   set(acngfs_cflags "${acngfs_cflags} ${arg}")
+endforeach(arg ${fuse_CFLAGS})
+
+# double-check and make sure it compiles
 SET(TESTSRC "
 #define _FILE_OFFSET_BITS 64
 #define FUSE_USE_VERSION 26
 #include <fuse.h>
 int main() { return 0; }
 ")
+SET(CMAKE_REQUIRED_FLAGS ${fuse_CFLAGS})
 CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_FUSE_26)
+
 if(fuse_FOUND AND HAVE_FUSE_26)
-
 ADD_EXECUTABLE(acngfs fs/httpfs.cc source/lockable.cc source/header.cc source/caddrinfo.cc source/acbuf.cc source/meta.cc source/acfg.cc source/acfg_defaults.cc)
-
-set(acngfs_cflags "${FLAGS_ACNG} -DMINIBUILD")
-
-# what a mess... convert sepator back to space
-foreach(arg ${fuse_CFLAGS})
-   set(acngfs_cflags "${acngfs_cflags} ${arg}")
-endforeach(arg ${fuse_CFLAGS})
-
 
 #message("hm, ${acngfs_cflags}")
 SET_TARGET_PROPERTIES(acngfs PROPERTIES COMPILE_FLAGS "${acngfs_cflags}" )

## apt-cacher-ng 0.6.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -134,6 +134,19 @@
       endif(NOT HAVE_MEMORY_SPTR)
    endif(NOT HAVE_TR1_MEMORY)
 endif(NOT HAVE_BOOST_SMARTPTR)
+
+SET(TESTSRC "
+#include <dlfcn.h>
+int main(int argc, char **argv)
+{
+  return dlsym(dlopen(*argv, RTLD_LAZY), *argv) ?0:1;
+}
+")
+SET(CMAKE_REQUIRED_FLAGS ${fuse_CFLAGS})
+SET(CMAKE_REQUIRED_LIBRARIES dl)
+CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_DLOPEN)
+SET(CMAKE_REQUIRED_LIBRARIES "")
+
 
 ######################################
 # checks done, save configuration    #
@@ -185,25 +198,29 @@
 # double-check and make sure it compiles
 SET(TESTSRC "
 #define _FILE_OFFSET_BITS 64
-#define FUSE_USE_VERSION 26
+#define FUSE_USE_VERSION 25
 #include <fuse.h>
 int main() { return 0; }
 ")
 SET(CMAKE_REQUIRED_FLAGS ${fuse_CFLAGS})
-CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_FUSE_26)
-
-if(fuse_FOUND AND HAVE_FUSE_26)
-ADD_EXECUTABLE(acngfs fs/httpfs.cc source/lockable.cc source/header.cc source/caddrinfo.cc source/acbuf.cc source/meta.cc source/acfg.cc source/acfg_defaults.cc)
+CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_FUSE_25)
+
+if(fuse_FOUND AND HAVE_FUSE_25)
+ADD_EXECUTABLE(acngfs fs/httpfs.cc source/lockable.cc source/header.cc source/caddrinfo.cc source/acbuf.cc source/meta.cc source/acfg.cc source/acfg_defaults.cc source/tcpconnect.cc)
 
 #message("hm, ${acngfs_cflags}")
 SET_TARGET_PROPERTIES(acngfs PROPERTIES COMPILE_FLAGS "${acngfs_cflags}" )
+if(HAVE_DLOPEN)
+TARGET_LINK_LIBRARIES(acngfs dl pthread)
+else(HAVE_DLOPEN)
 TARGET_LINK_LIBRARIES(acngfs ${fuse_LDFLAGS})
+endif(HAVE_DLOPEN)
 
 IF(HAVE_WL_AS_NEEDED)
 SET_TARGET_PROPERTIES(acngfs PROPERTIES LINK_FLAGS  -Wl,--as-needed)
 ENDIF(HAVE_WL_AS_NEEDED)
 
 
-else(fuse_FOUND AND HAVE_FUSE_26)
+else(fuse_FOUND AND HAVE_FUSE_25)
    message("FUSE not found or incompatible, not building acngfs")
-endif(fuse_FOUND AND HAVE_FUSE_26)
+endif(fuse_FOUND AND HAVE_FUSE_25)

## apt-cacher-ng 0.6.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -93,6 +93,19 @@
 int main(int argc, char **argv) { off_t yes(3); return (int) sendfile(1, 2, &yes, 4); }
 ")
 CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_LINUX_SENDFILE)
+
+SET(TESTSRC "
+#include <unistd.h>
+int main() { return pread(0, NULL, 0, 0); }
+")
+CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_PREAD)
+
+SET(TESTSRC "
+#define _GNU_SOURCE
+#include <fcntl.h>
+int main() { loff_t sin(12), sout(34); return splice(0, &sin, 1, &sout, 12, SPLICE_F_MORE); }
+")
+CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_LINUX_SPLICE)
 
 FIND_LIBRARY(HAVE_SOCKETLIB socket) # separate socket lib looks like Solaris-like environment
 if(HAVE_SOCKETLIB)

=== debian/changelog ===
apt-cacher-ng (0.6.6-1) unstable; urgency=low

  * New upstream version
    + auto-detection of removed architectures in expiration run (closes:620083)
    + release apt which opened many connection simultaneously from its
      "Waiting for headers" state (closes:638460)
  * fall-back to alternative tools if Perl modules are missing (closes:548348)
  * switched source format to 3.0 (quilt) with XZ compression
  * changed source and binary compression to XZ
  * fixed uncontrolled parallel build execution in debian/rules

 -- Eduard Bloch <blade@debian.org>  Sun, 21 Aug 2011 14:27:35 +0200

apt-cacher-ng (0.6.5-1) unstable; urgency=low

  * New upstream version
    + fixes various regressions
  * removed dependency on libfuse2 (now used via dlopen, moved to Suggests)
  * support new build-* targets in rules

 -- Eduard Bloch <blade@debian.org>  Sun, 07 Aug 2011 17:53:21 +0200

apt-cacher-ng (0.6.4-1) experimental; urgency=low

  * New upstream version
    + fixes potential pipeline freeze (closes: #628995)
    + supports "soft" blacklisting of bad hosts when important files are
      missing (see keyfile in documentation, closes: #616091)

 -- Eduard Bloch <blade@debian.org>  Mon, 01 Aug 2011 23:40:11 +0200

apt-cacher-ng (0.6.3-1) unstable; urgency=medium

  * New upstream releases (fixes endian detection, closes: #630372)

 -- Eduard Bloch <blade@debian.org>  Tue, 14 Jun 2011 22:47:01 +0200

apt-cacher-ng (0.6.2-1) unstable; urgency=low

  * New upstream release
    + fixes segfault after some failed connection attempts (closes: #624312)
    + includes cdn.debian.net (LP: #734348)
    + gcc-4.6 compilation fixes (LP: #765963)
    + adjusted regex for SF redirection to mscorefonts files (LP: #755085)

 -- Eduard Bloch <blade@debian.org>  Thu, 28 Apr 2011 21:34:49 +0200

apt-cacher-ng (0.6.1-1) unstable; urgency=low

  * New upstream release
  * Improved BindInterfaces description (closes: #545337)

 -- Eduard Bloch <blade@debian.org>  Mon, 28 Mar 2011 00:49:59 +0200

apt-cacher-ng (0.6-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Sat, 26 Feb 2011 16:37:24 +0100

## apt-cacher-ng 0.6.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -99,6 +99,12 @@
 int main() { return pread(0, NULL, 0, 0); }
 ")
 CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_PREAD)
+
+SET(TESTSRC "
+#include <unistd.h>
+int main() { return daemon(0, 0); }
+")
+CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_DAEMON)
 
 SET(TESTSRC "
 #define _GNU_SOURCE

=== debian/changelog ===
apt-cacher-ng (0.6.7-1) unstable; urgency=low

  * New upstream versions
    + implements extra keeping of obsolete package versions (closes: #634145)
    + configurable outgoing connection protocol (closes: #641257)

 -- Eduard Bloch <blade@debian.org>  Fri, 30 Sep 2011 16:37:18 +0200

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,14 @@
 Priority: optional
 Maintainer: Eduard Bloch <blade@debian.org>
 Build-Depends: debhelper (>= 7), cmake (>= 2.6.2), libbz2-dev, zlib1g-dev, liblzma-dev, libfuse-dev [!hurd-i386], pkg-config
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 Homepage: http://www.unix-ag.uni-kl.de/~bloch/acng/
 
 Package: apt-cacher-ng
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
 Recommends: perl (>> 5.8), ed
-Suggests: doc-base
+Suggests: doc-base, libfuse2 (>= 2.5)
 Description: caching proxy server for software repositories
  Apt-Cacher NG is a caching proxy for downloading packages from Debian-style
  software repositories (or possibly from other types).

=== debian/rules ===
--- 
+++ 
@@ -8,13 +8,14 @@
 CFLAGS = -Wall -g
 
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
-	CFLAGS += -O0
+CFLAGS += -O0
 else
-	CFLAGS += -O2
+CFLAGS += -O2
 endif
 
+NUMJOBS=2
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-        NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 endif
 
 
@@ -28,17 +29,15 @@
 
 	touch configure-stamp
 
+build: build-arch build-indep
 
-build: build-stamp
+build-indep:
 
-build-stamp: configure-stamp 
+build-arch: configure-stamp 
 	dh_testdir
-
-	# Add here commands to compile the package.
 	$(MAKE) -j$(NUMJOBS)
-	# may fail if halibut is not installed, doesn't matter
-	-$(MAKE) doc
-	#docbook-to-man debian/apt-cacher-ng.sgml > apt-cacher-ng.1
+	# may fail if halibut is not installed, doesn't matter. Also modifies binary pdf and format is not 3.0 yet
+	#-$(MAKE) doc
 	@-test -d ../unstripped && cp build/apt-cacher-ng ../unstripped/apt-cacher-ng.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') || true
 	touch $@
 
@@ -72,40 +71,29 @@
 	ln -sf ../../var/lib/apt-cacher-ng/backends_ubuntu.default $(CDIR)/backends_ubuntu.default
 
 # Build architecture-independent files here.
-binary-indep: build install
-# We have nothing to do by default.
+binary-indep: build-indep install
 
 # Build architecture-dependent files here.
-binary-arch: build install
+binary-arch: build-arch install
 	dh_testdir
 	dh_testroot
 	dh_installchangelogs ChangeLog
 	dh_installdocs
 	dh_installexamples conf/*.conf conf/debrep.hooks
-#	dh_install
-#	dh_installmenu
 	dh_installdebconf	
 	dh_installlogrotate
-#	dh_installemacsen
-#	dh_installpam
-#	dh_installmime
-#	dh_python
 	dh_installinit
 	dh_installcron
-#	dh_installinfo
 	dh_installman doc/man/*.8
-	#dh_installman doc/man/apt-cacher-ng.8
 	dh_link
 	dh_strip
 	dh_compress -X.pdf
 	dh_fixperms
-#	dh_perl
-#	dh_makeshlibs
 	dh_installdeb
 	dh_shlibdeps
 	dh_gencontrol
 	dh_md5sums
-	dh_builddeb
+	dh_builddeb -- -Zxz
 
 binary: binary-indep binary-arch
 .PHONY: build clean binary-indep binary-arch binary install configure

## apt-cacher-ng 0.6.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,32 @@
 cmake_minimum_required(VERSION 2.6)
+set(CMAKE_LEGACY_CYGWIN_WIN32 0)
+
 PROJECT(ACNG CXX C)
+
+INCLUDE (CheckIncludeFiles) 
+#INCLUDE (CheckLibraryExists)
+
 INCLUDE_DIRECTORIES(. ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR} "include")
-
-SET(FLAGS_ACNG " -pthread -Wall -D_FILE_OFFSET_BITS=64 ")
 
 # minimum prqs
 list(APPEND AcngLdList pthread z bz2)
 
 INCLUDE(CheckIncludeFiles)
 INCLUDE(CheckCXXSourceCompiles)
+
+# I don't need -rdynamic, thanks!
+SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
+SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")
+
+# common required flags
+SET(FLAGS_MIN " -pthread -Wall -D_FILE_OFFSET_BITS=64 ")
+
+#SET(CMAKE_REQUIRED_FLAGS " -std=gnu++0x ")
+#CHECK_CXX_SOURCE_COMPILES("int main() {return 0;}" NEEDS_GNU_0x)
+#if(NEEDS_GNU_0x)
+#   SET(FLAGS_MIN " ${FLAGS_MIN} -std=gnu++0x ")
+#endif(NEEDS_GNU_0x)
+
 
 #INCLUDE(FindZLIB) # broken, hangs for 10 seconds
 # header check should be enough, gzip should be everywhere nowadays
@@ -28,10 +46,13 @@
 
 INCLUDE_DIRECTORIES(${BZIP2_INCLUDE_DIR})
 
-SET(CMAKE_REQUIRED_FLAGS "-Wl,--as-needed")
+SET(CMAKE_REQUIRED_FLAGS " ${FLAGS_MIN} -Wl,--as-needed")
 SET(TESTSRC "int main() {return 0;}")
 CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_WL_AS_NEEDED)
-SET(CMAKE_REQUIRED_FLAGS "")
+
+# this flags are set to common base for the rest of the tests
+SET(CMAKE_REQUIRED_FLAGS " ${FLAGS_MIN} ")
+
 
 SET(CMAKE_REQUIRED_LIBRARIES lzma)
 SET(TESTSRC "
@@ -47,6 +68,21 @@
 ENDIF(HAVE_LZMA)
 SET(CMAKE_REQUIRED_LIBRARIES "")
 
+SET(CMAKE_REQUIRED_LIBRARIES wrap)
+SET(TESTSRC "
+#include <tcpd.h>
+int main() { request_info req; request_init(&req, RQ_FILE, 0, 0); fromhost(&req); return !hosts_access(&req); }
+")
+CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_LIBWRAP)
+IF(HAVE_LIBWRAP)
+   list(APPEND AcngLdList wrap)
+ELSE(HAVE_LIBWRAP)
+   MESSAGE("libwrap development files not usable, disabling support")
+   SET(HAVE_LIBWRAP)
+ENDIF(HAVE_LIBWRAP)
+SET(CMAKE_REQUIRED_LIBRARIES "")
+
+
 SET(TESTSRC "
 #include <wordexp.h>
 int main(int argc, char **argv) { wordexp_t p; return wordexp(*argv, &p, 0); }
@@ -117,6 +153,15 @@
 if(HAVE_SOCKETLIB)
    link_libraries(socket nsl)
 endif(HAVE_SOCKETLIB)
+
+#CHECK_INCLUDE_FILES(tcpd.h HAVE_LIBWRAP)
+#if(HAVE_LIBWRAP)
+## also check its library
+#  FIND_LIBRARY(tempvar wrapi)
+#  if(NOT tempvar)
+#     SET(HAVE_LIBWRAP "")
+#  endif(NOT tempvar)
+#endif(HAVE_LIBWRAP)
 
 INCLUDE(CheckTypeSize)
 CHECK_TYPE_SIZE(int SIZE_INT)
@@ -161,7 +206,6 @@
   return dlsym(dlopen(*argv, RTLD_LAZY), *argv) ?0:1;
 }
 ")
-SET(CMAKE_REQUIRED_FLAGS ${fuse_CFLAGS})
 SET(CMAKE_REQUIRED_LIBRARIES dl)
 CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_DLOPEN)
 SET(CMAKE_REQUIRED_LIBRARIES "")
@@ -173,21 +217,17 @@
 
 CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/include/acsyscap.h.in" "${CMAKE_BINARY_DIR}/acsyscap.h")
 
-
-# I don't need -rdynamic
-SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
-SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")
 
 FILE(GLOB SRCS "${CMAKE_SOURCE_DIR}/source/*.cc")
 ADD_EXECUTABLE(apt-cacher-ng ${SRCS})
 list(REMOVE_DUPLICATES AcngLdList)
 TARGET_LINK_LIBRARIES(apt-cacher-ng ${AcngLdList})
 
-SET_TARGET_PROPERTIES(apt-cacher-ng PROPERTIES COMPILE_FLAGS ${FLAGS_ACNG})
+SET_TARGET_PROPERTIES(apt-cacher-ng PROPERTIES COMPILE_FLAGS ${FLAGS_MIN})
 
 
 ADD_EXECUTABLE(in.acng client/client.cc)
-SET_TARGET_PROPERTIES(in.acng PROPERTIES COMPILE_FLAGS ${FLAGS_ACNG})
+SET_TARGET_PROPERTIES(in.acng PROPERTIES COMPILE_FLAGS ${FLAGS_MIN})
 
 IF(HAVE_WL_AS_NEEDED)
 SET_TARGET_PROPERTIES(in.acng apt-cacher-ng PROPERTIES LINK_FLAGS  -Wl,--as-needed)
@@ -208,7 +248,7 @@
 include(FindPkgConfig)
 pkg_check_modules(fuse fuse)
 
-set(acngfs_cflags "${FLAGS_ACNG} -DMINIBUILD")
+set(acngfs_cflags "${FLAGS_MIN} -DMINIBUILD")
 # what a mess... convert sepator back to space
 foreach(arg ${fuse_CFLAGS})
    set(acngfs_cflags "${acngfs_cflags} ${arg}")

=== debian/changelog ===
apt-cacher-ng (0.6.8-2) unstable; urgency=medium

  * Added libwrap0-dev to Build-Depends (closes: #646300)
  * Added newer dpkg to Pre-Depends (for xz compression support)

 -- Eduard Bloch <blade@debian.org>  Sun, 23 Oct 2011 00:45:56 +0200

apt-cacher-ng (0.6.8-1) unstable; urgency=low

  * New upstream version
    + supports optional IP filters via libwrap (closes: #635454)
    + adds more helpers for detection/removal of corrupted cache contents
      (closes: #644959)
    + extra expired file keeping was added in 0.6.7 (LP: #225483)
    + configurable timeout value for "hot" index file items (LP: #872365)
  * New version supports loading of resource files from non-configuration
    directories (i.e. /usr/lib/apt-cacher-ng). Removed symlinks for resource
    files in /etc/apt-cacher-ng.

 -- Eduard Bloch <blade@debian.org>  Sun, 16 Oct 2011 21:40:55 +0200

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,14 @@
 Section: net
 Priority: optional
 Maintainer: Eduard Bloch <blade@debian.org>
-Build-Depends: debhelper (>= 7), cmake (>= 2.6.2), libbz2-dev, zlib1g-dev, liblzma-dev, libfuse-dev [!hurd-i386], pkg-config
+Build-Depends: debhelper (>= 7), cmake (>= 2.6.2), libbz2-dev, zlib1g-dev, liblzma-dev, libfuse-dev [!hurd-i386], pkg-config, libwrap0-dev
 Standards-Version: 3.9.2
 Homepage: http://www.unix-ag.uni-kl.de/~bloch/acng/
 
 Package: apt-cacher-ng
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
+Pre-Depends: dpkg (>= 1.15.6)
 Recommends: perl (>> 5.8), ed
 Suggests: doc-base, libfuse2 (>= 2.5)
 Description: caching proxy server for software repositories

=== debian/rules ===
--- 
+++ 
@@ -13,9 +13,9 @@
 CFLAGS += -O2
 endif
 
-NUMJOBS=2
+PARJOBS=-j2
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+PARJOBS = -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 endif
 
 
@@ -35,8 +35,8 @@
 
 build-arch: configure-stamp 
 	dh_testdir
-	$(MAKE) -j$(NUMJOBS)
-	# may fail if halibut is not installed, doesn't matter. Also modifies binary pdf and format is not 3.0 yet
+	$(MAKE) $(PARJOBS)
+	# may fail if halibut is not installed, doesn't matter
 	#-$(MAKE) doc
 	@-test -d ../unstripped && cp build/apt-cacher-ng ../unstripped/apt-cacher-ng.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') || true
 	touch $@
@@ -66,7 +66,7 @@
 	> $(CDIR)/backends_debian
 	> $(CDIR)/backends_debvol
 	> $(CDIR)/backends_ubuntu
-	cd $(CDIR) && cp -s ../../usr/lib/apt-cacher-ng/{*mirror*,*.html,*.css} . 
+#	cd $(CDIR) && cp -s ../../usr/lib/apt-cacher-ng/{*mirror*,*.html,*.css} . 
 	ln -sf ../../var/lib/apt-cacher-ng/backends_debian.default $(CDIR)/backends_debian.default
 	ln -sf ../../var/lib/apt-cacher-ng/backends_ubuntu.default $(CDIR)/backends_ubuntu.default

## apt-cacher-ng 0.6.10

=== debian/changelog ===
apt-cacher-ng (0.6.10-2) unstable; urgency=low

  * Release to Unstable

 -- Eduard Bloch <blade@debian.org>  Wed, 30 Nov 2011 01:22:41 +0100

apt-cacher-ng (0.6.10-1) experimental; urgency=low

  * New upstream version

 -- Eduard Bloch <blade@debian.org>  Sat, 26 Nov 2011 13:09:45 +0100

apt-cacher-ng (0.6.9-1) experimental; urgency=low

  * New upstream release, testing downloader code changes

 -- Eduard Bloch <blade@debian.org>  Sun, 06 Nov 2011 20:20:33 +0100

## apt-cacher-ng 0.6.11

=== debian/changelog ===
apt-cacher-ng (0.6.11-1) unstable; urgency=low

  * Start init script at S18, not before bind (closes: 650726). Also adds the
    reference to LSB init info block.
  * specified effective user/group in logrotate config
  * Adds sample config snippet for apt.conf.d to examples
  * added Dutch translation of debconf templates (closes: 652020)
  * documented AllowUserPorts (available since 0.6.10, closes: 648802)

 -- Eduard Bloch <blade@debian.org>  Mon, 26 Dec 2011 16:38:05 +0100

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,7 @@
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
 CFLAGS += -O0
 else
-CFLAGS += -O2
+CFLAGS += -O3
 endif
 
 PARJOBS=-j2
@@ -79,10 +79,10 @@
 	dh_testroot
 	dh_installchangelogs ChangeLog
 	dh_installdocs
-	dh_installexamples conf/*.conf conf/debrep.hooks
+	dh_installexamples conf/*.conf conf/debrep.hooks doc/000apt-cacher-ng-proxy
 	dh_installdebconf	
 	dh_installlogrotate
-	dh_installinit
+	dh_installinit -- defaults 18
 	dh_installcron
 	dh_installman doc/man/*.8
 	dh_link

## apt-cacher-ng 0.6.12

=== debian/changelog ===
apt-cacher-ng (0.6.12-1) unstable; urgency=low

  * New upstream version
  * Added use of dpkg-buildflags (for hardening)

 -- Eduard Bloch <blade@debian.org>  Sun, 15 Jan 2012 16:10:09 +0100

## apt-cacher-ng 0.7

=== debian/changelog ===
apt-cacher-ng (0.7-1) unstable; urgency=medium

  * New upstream releases
    + fixes asymmetric lifetime handling for file objects with URL encoded ~
      char in the filename (closes: #658550, #658680)

 -- Eduard Bloch <blade@debian.org>  Sun, 05 Feb 2012 22:42:53 +0100

=== debian/control ===
--- 
+++ 
@@ -3,6 +3,7 @@
 Priority: optional
 Maintainer: Eduard Bloch <blade@debian.org>
 Build-Depends: debhelper (>= 7), cmake (>= 2.6.2), libbz2-dev, zlib1g-dev, liblzma-dev, libfuse-dev [!hurd-i386], pkg-config, libwrap0-dev
+Build-Conflicts: binutils-gold
 Standards-Version: 3.9.2
 Homepage: http://www.unix-ag.uni-kl.de/~bloch/acng/

## apt-cacher-ng 0.7.1

=== debian/changelog ===
apt-cacher-ng (0.7.1-1) unstable; urgency=low

  * New upstream releases
    + attempts to detect errors in HTTP stream and invalidate possibly
      damaged files (closes: #658550)
    + don't consider (almost) empty uncompressed file as damaged
      (closes: #660622)

 -- Eduard Bloch <blade@debian.org>  Mon, 20 Feb 2012 22:13:12 +0100

## apt-cacher-ng 0.7.2

=== debian/changelog ===
apt-cacher-ng (0.7.2-1ubuntu1) precise; urgency=low

  * Merge from Debian testing.  Remaining changes:
    - debian/apt-cacher-ng.logrotate:
      Comment out the "su" lines as this requires logrotate 3.8.1 which isn't
      in Ubuntu yet.

 -- Daniel Hahler <ubuntu@thequod.de>  Mon, 09 Apr 2012 17:16:08 +0200

apt-cacher-ng (0.7.2-1) unstable; urgency=low

  * New upstream releases (closes: #661971)
  * Added Danish translation from Joe Dalton (closes: #660771)

 -- Eduard Bloch <blade@debian.org>  Sat, 03 Mar 2012 17:48:57 +0100

apt-cacher-ng (0.7.1-1ubuntu1) precise; urgency=low

  * debian/apt-cacher-ng.logrotate:
    Comment out the "su" lines as this requires logrotate 3.8.1 which isn't in
    Ubuntu yet.

 -- Michael Bienia <geser@ubuntu.com>  Sun, 26 Feb 2012 12:24:57 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: apt-cacher-ng
 Section: net
 Priority: optional
-Maintainer: Eduard Bloch <blade@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Eduard Bloch <blade@debian.org>
 Build-Depends: debhelper (>= 7), cmake (>= 2.6.2), libbz2-dev, zlib1g-dev, liblzma-dev, libfuse-dev [!hurd-i386], pkg-config, libwrap0-dev
 Build-Conflicts: binutils-gold
 Standards-Version: 3.9.2

## apt-cacher-ng 0.7.7

=== debian/changelog ===
apt-cacher-ng (0.7.7-1ubuntu1) quantal; urgency=low

  * Merge from Debian.  Remaining changes:
    - debian/apt-cacher-ng.logrotate:
      Comment out the "su" lines as this requires logrotate 3.8.1 which isn't
      in Ubuntu yet.
    - drop conflict on logrotate < 3.8.1

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sun, 05 Aug 2012 09:54:58 -0400

apt-cacher-ng (0.7.7-1) experimental; urgency=low

  * New upstream releasee
    + pass-through mode for allowed hosts (LP: #647212)
    + possible fixes of file descriptor objects expiration (closes: #677983)

 -- Eduard Bloch <blade@debian.org>  Sat, 04 Aug 2012 20:50:16 +0200

apt-cacher-ng (0.7.6-1) unstable; urgency=medium

  * New upstream release
    + more path pattern(s) for CentOS / Scientific Linux (LP: #1006844)
    + working around confusing proxy behavior and related issues with
      symptoms similar to #672801 (closes: #676214)

 -- Eduard Bloch <blade@debian.org>  Thu, 07 Jun 2012 17:14:57 +0200

apt-cacher-ng (0.7.5-1) unstable; urgency=low

  * New upstream release
    + fixes for corner cases of bug #672801

 -- Eduard Bloch <blade@debian.org>  Thu, 31 May 2012 00:27:55 +0200

apt-cacher-ng (0.7.4-1) unstable; urgency=medium

  * New upstream release 
    + prevents endless looping in certain situations (LP: #999915)
    + more tolerance to unstable connections and behavior fix for conflicting
      downloads in maintenance mode (closes: #672801)
  * added a bug-script to present some instructions

 -- Eduard Bloch <blade@debian.org>  Thu, 24 May 2012 15:55:17 +0200

apt-cacher-ng (0.7.3-1) unstable; urgency=low

  * New upstream release
    + Fixes FTBFS (missing unistd.h include, closes: #667100)
    + option to disable Range/If-Range for volatile files (LP: #983128)
    + Fixes storage of HTTP header data in cached files under certain
      circumstances (now really closes: #644959)
  * Conflict with older logrotate not understanding "su" (closes: #662760)
  * Process user/group is configurable via default file now (closes: #668421)

 -- Eduard Bloch <blade@debian.org>  Fri, 20 Apr 2012 09:27:13 +0200

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Eduard Bloch <blade@debian.org>
-Build-Depends: debhelper (>= 7), cmake (>= 2.6.2), libbz2-dev, zlib1g-dev, liblzma-dev, libfuse-dev [!hurd-i386], pkg-config, libwrap0-dev
+Build-Depends: debhelper (>= 7.2.3), cmake (>= 2.6.2), libbz2-dev, zlib1g-dev, liblzma-dev, libfuse-dev [!hurd-i386], pkg-config, libwrap0-dev
 Build-Conflicts: binutils-gold
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://www.unix-ag.uni-kl.de/~bloch/acng/
 
 Package: apt-cacher-ng
@@ -13,6 +13,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
 Pre-Depends: dpkg (>= 1.15.6)
 Recommends: perl (>> 5.8), ed
+#Conflicts: logrotate (<< 3.8.0)
 Suggests: doc-base, libfuse2 (>= 2.5)
 Description: caching proxy server for software repositories
  Apt-Cacher NG is a caching proxy for downloading packages from Debian-style

## apt-cacher-ng 0.7.11

=== CMakeLists.txt ===
--- 
+++ 
@@ -265,7 +265,7 @@
 CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_FUSE_25)
 
 if(fuse_FOUND AND HAVE_FUSE_25)
-ADD_EXECUTABLE(acngfs fs/httpfs.cc source/lockable.cc source/header.cc source/caddrinfo.cc source/acbuf.cc source/meta.cc source/acfg.cc source/acfg_defaults.cc source/tcpconnect.cc)
+ADD_EXECUTABLE(acngfs fs/httpfs.cc source/lockable.cc source/header.cc source/caddrinfo.cc source/acbuf.cc source/meta.cc source/acfg.cc source/acfg_defaults.cc source/tcpconnect.cc source/dlcon.cc source/fileitem.cc)
 
 #message("hm, ${acngfs_cflags}")
 SET_TARGET_PROPERTIES(acngfs PROPERTIES COMPILE_FLAGS "${acngfs_cflags}" )

=== debian/changelog ===
apt-cacher-ng (0.7.11-2) stable; urgency=medium

  * Do not print the submitted (raw) file path in the response body of a 403
    message (CVE-2014-4510), avoiding potential use for XSS attacks

 -- Eduard Bloch <blade@debian.org>  Tue, 24 Jun 2014 21:24:28 +0200

apt-cacher-ng (0.7.11-1) unstable; urgency=low

  * New upstream release
    + fixes a segfaulting bug within the new code (closes: #694620)
    + spelling correction in the web interface (threat/treat, closes: #695120)

 -- Eduard Bloch <blade@debian.org>  Wed, 19 Dec 2012 20:14:46 +0100

apt-cacher-ng (0.7.10-1) unstable; urgency=medium

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Mon, 05 Nov 2012 23:27:29 +0100

apt-cacher-ng (0.7.9-1) unstable; urgency=low

  * New upstream release
    + fixes regular downloads in ForceManaged mode, closes: #692373)

 -- Eduard Bloch <blade@debian.org>  Mon, 05 Nov 2012 23:17:06 +0100

apt-cacher-ng (0.7.8-1) unstable; urgency=low

  * New upstream release
    + improved redirection handling (closes: #683803)
    + workarounds for stuck download descriptors (now probably really
      closes:#677983)
  * Cron jobs displays max. 5 recent operation logs (LP: #1074474)

 -- Eduard Bloch <blade@debian.org>  Sun, 04 Nov 2012 20:36:32 +0100

apt-cacher-ng (0.7.7-2) unstable; urgency=low

  * Unstable upload (no changes, hope that it closes: #677983)

 -- Eduard Bloch <blade@debian.org>  Sat, 08 Sep 2012 18:17:22 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: apt-cacher-ng
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Eduard Bloch <blade@debian.org>
+Maintainer: Eduard Bloch <blade@debian.org>
 Build-Depends: debhelper (>= 7.2.3), cmake (>= 2.6.2), libbz2-dev, zlib1g-dev, liblzma-dev, libfuse-dev [!hurd-i386], pkg-config, libwrap0-dev
 Build-Conflicts: binutils-gold
 Standards-Version: 3.9.3
@@ -13,7 +12,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
 Pre-Depends: dpkg (>= 1.15.6)
 Recommends: perl (>> 5.8), ed
-#Conflicts: logrotate (<< 3.8.0)
+Conflicts: logrotate (<< 3.8.0)
 Suggests: doc-base, libfuse2 (>= 2.5)
 Description: caching proxy server for software repositories
  Apt-Cacher NG is a caching proxy for downloading packages from Debian-style

=== debian/rules ===
--- 
+++ 
@@ -5,22 +5,19 @@
 SHELL=/bin/bash
 CDIR=$(CURDIR)/debian/apt-cacher-ng/etc/apt-cacher-ng/
 
-CFLAGS = -Wall -g
+CFLAGS = $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS) -Wall
+export CFLAGS
+CXXFLAGS=$(CFLAGS)
+export CXXFLAGS
+LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS) 
+export LDFLAGS
 
-ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
-CFLAGS += -O0
-else
-CFLAGS += -O3
-endif
 
 PARJOBS=-j2
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 PARJOBS = -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 endif
 
-
-CXXFLAGS=$(CFLAGS)
-export CXXFLAGS
 
 configure: configure-stamp
 configure-stamp:
@@ -79,12 +76,13 @@
 	dh_testroot
 	dh_installchangelogs ChangeLog
 	dh_installdocs
-	dh_installexamples conf/*.conf conf/debrep.hooks doc/000apt-cacher-ng-proxy
+	dh_installexamples conf/*.conf conf/debrep.hooks doc/000apt-cacher-ng-proxy contrib/*.conf
 	dh_installdebconf	
 	dh_installlogrotate
 	dh_installinit -- defaults 18
 	dh_installcron
 	dh_installman doc/man/*.8
+	dh_bugfiles
 	dh_link
 	dh_strip
 	dh_compress -X.pdf
